package DrawingObjects;
/*import src.*;
import src.Dop.DopClassBlack;
import src.Dop.DopClassWhite;
import src.Entities.*;
import src.Dop.IDop;*/
import Dop.DopClassTriangle;
import Dop.DopClassRect;
import Dop.IDop;
import Entities.EntityCar;
import MovementStrategy.*;

import java.awt.*;
import java.util.Random;

public class DrawingCar {
    public EntityCar EntityCar;

    private int _pictureWidth;

    private int _pictureHeight;

    protected int _startPosX;

    protected int _startPosY;

    private int _carWidth = 110;

    private int _carHeight = 60;

    /// <summary>
    /// Координата X объекта
    /// </summary>
    public int GetPosX(){return _startPosX;};
    /// <summary>
    /// Координата Y объекта
    /// </summary>
    public int GetPosY(){return _startPosY;}
    /// <summary>
    /// Ширина объекта
    /// </summary>
    public int GetWidth(){return  _carWidth;};
    /// <summary>
    /// Высота объекта
    /// </summary>
    public int GetHeight(){return _carHeight;}
    public IDop wheels;




    public DrawingCar(int speed, double weight, Color bodyColor, int width, int height)
    {
        if(width < _carWidth || height < _carHeight)
        {
            return;
        }
        _pictureWidth = width;
        _pictureHeight = height;

        EntityCar = new EntityCar(speed, weight, bodyColor);

    }
    public EntityCar getEntity(){
        return EntityCar;
    }

    protected DrawingCar(int speed, double weight, Color bodyColor, int
            width, int height, int carWidth, int carHeight)
    {
        if (width <= _carWidth || height <= _carHeight)
        {
            return;
        }
        _pictureWidth = width;
        _pictureHeight = height;
        _carWidth = carWidth;
        _carHeight = carHeight;
        EntityCar = new EntityCar(speed, weight, bodyColor);
    }

    public DrawingCar(EntityCar entityCar,IDop wheels)
    {
        EntityCar = entityCar;
        this.wheels = wheels;
        _pictureWidth = 1000;
        _pictureHeight = 1000;
        _carWidth = 110;
        _carHeight = 60;
    }

    public void SetPosition(int x, int y)
    {
        if (x < 0 || x >= _pictureWidth || y < 0 || y >= _pictureHeight)
        {
            _startPosX = 0;
            _startPosY = 0;
        }
        _startPosX = x;
        _startPosY = y;
    }

    public void MoveTransport(Direction direction)
    {
        if (!CanMove(direction) || EntityCar == null)
        {
            return;
        }
        switch (direction)
        {
            //влево
            case Left:
                _startPosX -= (int)EntityCar.Step();
                break;
            //вверх
            case Up:
                _startPosY -= (int)EntityCar.Step();
                break;
            // вправо
            case Right:
                _startPosX += (int)EntityCar.Step();
                break;
            //вниз
            case Down:
                _startPosY += (int)EntityCar.Step();
                break;
        }
    }

    public boolean CanMove(Direction direction)
    {
        if (EntityCar == null)
        {
            return false;
        }
        switch (direction)
        {
            //влево
            case Left:
                return  (_startPosX - EntityCar.Step()) > 0;

                //вверх
            case Up:
                return _startPosY - EntityCar.Step() > 0;

                // вправо
            case Right:
                return _startPosX + EntityCar.Step() + _carWidth < _pictureWidth;

                //вниз
            case Down:
                return _startPosY + EntityCar.Step() + _carHeight < _pictureHeight;

            default:
                return false;

        }
    }


    public void DrawTransport(Graphics g)
    {

        if (EntityCar == null)
        {
            return;
        }

        g.setColor(EntityCar.BodyColor);

        //границы автомобиля
        g.fillRect(_startPosX, _startPosY + 35, 110, 10);
        g.fillRect( _startPosX + 85, _startPosY, 25, 35);
        /*g.fillOval( _startPosX, _startPosY + 35 + 10, 15, 15);
        g.fillOval( _startPosX + 15, _startPosY + 35 + 10, 15, 15);
        g.fillOval( _startPosX + 95, _startPosY + 35 + 10, 15, 15);*/

        if (wheels == null){return;}
        wheels.drawWheels(g, _startPosX, _startPosY, EntityCar.BodyColor);
    }
    public IMoveableObject GetMoveableObject(){return new DrawingObjectCar(this);}

}
