package DrawingObjects;

import MovementStrategy.Direction;
import MovementStrategy.IMoveableObject;
import MovementStrategy.ObjectParameters;

public class DrawingObjectCar implements IMoveableObject{
    private DrawingCar _drawningCar;
    public DrawingObjectCar(DrawingCar drawningCar)
    {
        _drawningCar = drawningCar;
    }
    public ObjectParameters GetObjectPosition()
    {


            if (_drawningCar == null || _drawningCar.EntityCar ==
                    null)
            {
                return null;
            }
            return new ObjectParameters(_drawningCar.GetPosX(),
                    _drawningCar.GetPosY(), _drawningCar.GetWidth(), _drawningCar.GetHeight());

    }
    public int GetStep() {
        if(_drawningCar.getEntity() == null)
            return 0;
        return (int)_drawningCar.getEntity().Step();
    }
    public boolean CheckCanMove(Direction direction){
        if(_drawningCar == null)
            return false;
        return _drawningCar.CanMove(direction);
    }

    public void MoveObject(Direction direction){
        if(_drawningCar == null)
            return;
        _drawningCar.MoveTransport(direction);
    }
}
