package Generics;

public class SetGeneric<T extends Object> {
    private Object[] _places;

    public int Count() {
        return _places.length;
    }

    public SetGeneric(int count)
    {
        _places = new Object[count];
    }

    public int Insert(T car)
    {
        return Insert(car,0);
    }

    public int Insert(T car, int position)
    {
        if (!(position >= 0 && position < Count()))
            return -1;
        if (_places[position] != null)
        {
            int indexEnd = position + 1;
            while (_places[indexEnd] != null)
            {
                indexEnd++;
            }
            for (int i = indexEnd + 1; i > position; i--)
            {
                _places[i] = _places[i - 1];
            }

        }
        _places[position] = car;
        return position;
    }

    public boolean Remove(int position)
    {
        if (position < Count() && position >= 0)
        {
            _places[position] = null;
            return true;
        }
        return false;
    }

    public T Get(int position)
    {
        if (position < Count() && position >= 0) { return (T)_places[position]; }
        return null;
    }
}
