package MovementStrategy;

import DrawingObjects.DrawingCar;
import Entities.*;

public class DrawingObjectCar implements IMoveableObject {
    private DrawingCar _drawningCar = null;

    public DrawingObjectCar(DrawingCar drawningCar) {
        _drawningCar = drawningCar;
    }

    public ObjectParameters GetObjectPosition() {
        if (_drawningCar == null || _drawningCar.EntityCar == null) {
            return null;
        }
        return new ObjectParameters(_drawningCar.GetPosX(), _drawningCar.GetPosY(), _drawningCar.GetWidth(), _drawningCar.GetHeight());
    }

    public int GetStep() {
        return (int) (_drawningCar.EntityCar.Step());
    }

    public boolean CheckCanMove(Direction direction) {
        if (_drawningCar.CanMove(direction)){
            return true;
        }
        return false;
    }

    public void MoveObject(Direction direction) {
        _drawningCar.MoveTransport(direction);
    }
}
